#ifndef _XBF_H_
#define _XBF_H_

struct xbf {
	void		*_xbf_mem;
	size_t		 _xbf_memsize;
#define _XBF_ERRMSG_LEN	1024
	char		 _xbf_errmsg[_XBF_ERRMSG_LEN];

	const char	*xbf_fname;
	const char	*xbf_ncdname;
	const char	*xbf_partname;
	const char	*xbf_time;
	const char	*xbf_date;
	uint32_t	 xbf_bitlen;
	const char	*xbf_bitptr;
};

#define XBF_HDR_SIZE 72

struct xbf *xbf_open(const char *fname);
int xbf_close(struct xbf *xbf);
const char *xbf_errmsg(struct xbf *xbf);
struct xbf *xbf_err(struct xbf *xbf, const char *fmt, ...);
int xbf_erri(struct xbf *xbf, const char *fmt, ...);
size_t xbf_get_bitlen(struct xbf *xbf);
const unsigned char *xbf_get_bitptr(struct xbf *xbf);
const char *xbf_get_partname(struct xbf *xbf);
const char *xbf_get_date(struct xbf *xbf);
const char *xbf_get_time(struct xbf *xbf);
const char *xbf_get_ncdname(struct xbf *xbf);
const char *xbf_get_fname(struct xbf *xbf);
void xbf_print_fp(FILE *fp, struct xbf *xp);
void xbf_print(struct xbf *xbf);
int xbf_opened(struct xbf *xbf);

#endif /* _XBF_H_ */
